	.386
	.model flat,stdcall
	 option casemap:none

	include \masm32\include\windows.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\gdi32.inc
	include vfw32\vfw32.inc
;	include avicap32\avicap32.inc
	
	includelib \masm32\lib\user32.lib
	includelib \masm32\lib\kernel32.lib
	includelib \masm32\lib\gdi32.lib
	includelib vfw32\vfw32.lib
;	includelib avicap32\avicap32.lib



TEXT_ MACRO your_text:VARARG
	LOCAL text_string
	.data
	 text_string db your_text,0
	.code
	EXITM <addr text_string>
ENDM


CAPDRIVERCAPS struct
	wDeviceIndex    		dd ?
	fHasOverlay    			dd ?
	fHasDlgVideoSource		dd ?
	fHasDlgVideoFormat		dd ?
	fHasDlgVideoDisplay		dd ?
	fCaptureInitialized		dd ?
	fDriverSuppliesPalettes	dd ?
	hVideoIn				dd ?
	hVideoOut				dd ?
	hVideoExtIn				dd ?
	hVideoExtOut			dd ?
CAPDRIVERCAPS ends

camera_combo			equ	200
camera_screen			equ	201
camera_source			equ 202
camera_format			equ 203
camera_display			equ 204
save_bmp				equ 205

FramesPerSecond			equ 30
       
.data

hInstance				dd	?
hWnd					dd	?
CaptureCaps				CAPDRIVERCAPS <?>
CaptureDeviceCount		dd	?
hCaptureDevice			dd	?
hCaptureCombobox		dd	?
hCaptureWnd				dd	?
pic_number				dd	?
string_buffer			db	128 dup (?)

.code

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

	.if	uMsg == WM_INITDIALOG
		mov		eax,hWin
		mov		hWnd,eax
		mov		hCaptureDevice,0

		invoke	GetDlgItem,hWnd,camera_combo
		mov		hCaptureCombobox,eax

        ; Zoek alle aanwezige video_opname apparaten

		mov		[CaptureDeviceCount],0
		invoke	SendMessage,hCaptureCombobox,CB_ADDSTRING,0,TEXT_("Geen camera")
next_capture_device:
		invoke	capGetDriverDescription,CaptureDeviceCount,addr string_buffer,sizeof string_buffer,0,0
		test	eax,eax
		jz		thats_all
		invoke	SendMessage,hCaptureCombobox,CB_ADDSTRING,0,addr string_buffer
		invoke	RtlZeroMemory,addr string_buffer,sizeof string_buffer
		inc		[CaptureDeviceCount]
		jmp		next_capture_device
thats_all:

		.if	CaptureDeviceCount == 0
			invoke	MessageBox,hWin,TEXT_("No capture devices found !",13,10,"program terminated...."), \
					TEXT_("Siekmanski zegt: Helaas pindakaas....?"),MB_OK OR MB_ICONWARNING ;MB_ICONERROR
			jmp	sluitprog
		.endif

		invoke	SendMessage,hCaptureCombobox,CB_SETCURSEL,1,0

		invoke	GetDlgItem,hWnd,camera_screen
		invoke	capCreateCaptureWindow,0,WS_CHILD OR  WS_VISIBLE,0,0,320,240,eax,0		;windowhandle in eax
		.if eax == NULL
			invoke	MessageBox,hWin,TEXT_("Kan geen Video CaptureWindow maken !",13,10,"programma wordt beeindigd...."), \
					TEXT_("Siekmanski zegt: Helaas....?"),MB_OK OR MB_ICONWARNING ;MB_ICONERROR
			jmp	sluitprog
		.endif

	mov	hCaptureWnd,eax
   
   	mov	hCaptureDevice,0
	; Probeer eerste opnamebron die we vinden
	invoke	SendMessage,hCaptureWnd,WM_CAP_DRIVER_CONNECT,hCaptureDevice,0
	invoke	SendMessage,hCaptureWnd,WM_CAP_DRIVER_GET_CAPS,sizeof CaptureCaps,addr CaptureCaps

	invoke	SendMessage,hCaptureWnd,WM_CAP_SET_SCALE,TRUE,0
	invoke	SendMessage,hCaptureWnd,WM_CAP_SET_PREVIEWRATE,1,0
	invoke	SendMessage,hCaptureWnd,WM_CAP_SET_PREVIEW,TRUE,0
	invoke	SendMessage,hCaptureWnd,WM_CAP_SET_OVERLAY,TRUE,0

	xor	eax,eax
    ret

	.elseif uMsg == WM_COMMAND
		mov		eax,wParam
		mov		ecx,eax
        shr		ecx,16
        
		.if ecx == CBN_SELCHANGE      
			mov		eax,lParam
			.if eax == hCaptureCombobox
				invoke	SendMessage,hCaptureWnd,WM_CAP_DRIVER_DISCONNECT,0,0
				invoke	SendMessage,hCaptureCombobox,CB_GETCURSEL,0,0
				.if eax == 0
					invoke	SendMessage, hCaptureWnd,WM_CAP_DRIVER_DISCONNECT,0,0
					mov	eax,eax
					ret
				.endif

				dec 	eax
				mov		hCaptureDevice,eax

				invoke	SendMessage,hCaptureWnd,WM_CAP_DRIVER_CONNECT,hCaptureDevice,0
				invoke	SendMessage,hCaptureWnd,WM_CAP_DRIVER_GET_CAPS,sizeof CaptureCaps,addr CaptureCaps
				invoke	SendMessage,hCaptureWnd,WM_CAP_SET_PREVIEW,TRUE,0
				invoke	SendMessage,hCaptureWnd,WM_CAP_SET_PREVIEWRATE,1000/FramesPerSecond,0
				invoke	SendMessage,hCaptureWnd,WM_CAP_SET_SCALE,TRUE,0
				invoke	SendMessage,hCaptureWnd,WM_CAP_SET_OVERLAY,TRUE,0
				xor	eax,eax
	    		ret
			.endif

		.elseif eax == camera_source     ; cam instellingen
            	.if (CaptureCaps.fHasDlgVideoSource)
					invoke	SendMessage,hCaptureWnd,WM_CAP_DLG_VIDEOSOURCE,0,0
               	.endif

		.elseif eax == camera_format     ; cam instellingen
				.if (CaptureCaps.fHasDlgVideoFormat)
					invoke	SendMessage,hCaptureWnd,WM_CAP_DLG_VIDEOFORMAT,0,0
				.endif

		.elseif eax == camera_display     ; cam instellingen
				.if (CaptureCaps.fHasDlgVideoDisplay)
					invoke	SendMessage,hCaptureWnd,WM_CAP_DLG_VIDEODISPLAY,0,0
				.endif

		.elseif eax == save_bmp     
				inc		pic_number 
				invoke  wsprintf,addr string_buffer,TEXT_("Plaatje_%d.bmp",0),pic_number
				invoke  SendMessage,hCaptureWnd,WM_CAP_FILE_SAVEDIBA,0,addr string_buffer
		.endif
	xor	eax,eax
   	ret

	.elseif uMsg == WM_CLOSE
		invoke SendMessage,hCaptureWnd,WM_CAP_DRIVER_DISCONNECT,0,0
sluitprog:
		invoke EndDialog,hWin,0
	.endif

    xor		eax,eax
	ret
DlgProc endp

start:
	invoke	GetModuleHandle,NULL
	mov		hInstance,eax
        	invoke	DialogBoxParam,hInstance,TEXT_("camera"),0,addr DlgProc,0
	invoke	ExitProcess,eax
end start
